c
      subroutine fault(kx,ky,d1,d2,z,cux,cuy,cuz,
     +                               cvx,cvy,cvz,
     +                               cwx,cwy,cwz,
     +                               c3x,c3y,c3z)
c
c  input
c    kx  - x wavenumber        (1/km)
c    ky  - y wavenumber        (1/km)
c    d1  - bottom of fault d1 < d2 < 0. (km)
c    d2  - top of fault        (km)
c    z   - observation plane   (km)
c
c  output
c    cux,cuy,cuz  - elements of force/displacement matrix
c    cvx,cvy,cvz               (km**2/Pa)
c    cwx,cwy,cwz
c    c3x,c3y,c3z  - non-zero vertical stress at surface z=0
c                              (km)
c
      implicit complex (c)
      implicit real*4 (k)
c
c  routine to compute the greens function for a fault element
c
      common/elastic/rlam,rmu,rc,rd,alph,pi
c
      if (kx.eq.0.and.ky.eq.0.) then
        cux=cmplx(0.,0.)
        cuy=cmplx(0.,0.)
        cuz=cmplx(0.,0.)
        cvx=cmplx(0.,0.)
        cvy=cmplx(0.,0.)
        cvz=cmplx(0.,0.)
        cwx=cmplx(0.,0.)
        cwy=cmplx(0.,0.)
        cwz=cmplx(0.,0.)
        cwz=cmplx(0.,0.)
        c3y=cmplx(0.,0.)
        c3z=cmplx(0.,0.)
        c3z=cmplx(0.,0.)
      else
c
c   compute the source
c
        call fterm(kx,ky,d1,d2,z,uxs,uys,uzs,
     +                           vys,vzs,wzs,
     +                           c3x,c3y,c3z)
c
c   compute the image
c
        call fterm(kx,ky,-d1,-d2,z,uxi,uyi,uzi,
     +                             vyi,vzi,wzi,
     +                             c3x,c3y,c3z)
c
        cux=cmplx(uxs+uxi,0)
        cuy=cmplx(uys+uyi,0)
        cuz=cmplx(0,uzs+uzi)
c
        cvx=cmplx(uys+uyi,0.)
        cvy=cmplx(vys+vyi,0.)
        cvz=cmplx(0.,vzs+vzi)
c
        cwx=cmplx(0.,uzs-uzi)
        cwy=cmplx(0.,vzs-vzi)
        cwz=cmplx(wzs-wzi,0.)
      endif
      return
      end
c
